require 'uu/os/gvc/component'
require 'uu/os/gvc/styleable'

module UU
  module OS
    module GVC

      # Widget component.
      class Widget < UU::OS::GVC::Component

        # The code (type) of the widget.
        # @return [String]
        attr_reader :widget_code

        # Sets attribute with given name to given value.
        #
        # @param [String] name The name of the attribute to set.
        # @param [Object] value The value of the attribute to set.
        def set_attribute(name, value)
          attributes[name.downcase.to_sym] = nil # backward compatibility
          attributes[name.to_sym] = value
        end

        # Returns the value of the attribute or nil.
        #
        # @param [String] name The name of the attribute whose value to return.
        # @return [Object] The value of the attribute or nil.
        def get_attribute(name)
          return attributes[name.downcase.to_sym] if !attributes.has_key?(name.to_sym) # backward compatibility
          attributes[name.to_sym]
        end

        def widget_code
          attributes[:widgetCode]
        end

      end
    end
  end
end
